"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Batch = void 0;
class Batch {
    constructor(patches) {
        this.patches = patches;
    }
    rebase(serverTime) {
        const transformHorizon = serverTime;
        const length = this.patches.length;
        const patches = [];
        for (let i = 0; i < length; i++) {
            const patch = patches[i];
            patches.push(patch.rebase(serverTime, transformHorizon));
            serverTime += patch.span();
        }
        return new Batch(patches);
    }
    clone() {
        return new Batch(this.patches.map((patch) => patch.clone()));
    }
}
exports.Batch = Batch;
