"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Batch = void 0;
var Batch = (function () {
    function Batch(patches) {
        this.patches = patches;
    }
    Batch.prototype.rebase = function (serverTime) {
        var transformHorizon = serverTime;
        var length = this.patches.length;
        var patches = [];
        for (var i = 0; i < length; i++) {
            var patch = patches[i];
            patches.push(patch.rebase(serverTime, transformHorizon));
            serverTime += patch.span();
        }
        return new Batch(patches);
    };
    Batch.prototype.clone = function () {
        return new Batch(this.patches.map(function (patch) { return patch.clone(); }));
    };
    return Batch;
}());
exports.Batch = Batch;
